﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_draw_equations
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Redraw on resize.
        private void Form1_Load(object sender, EventArgs e)
        {
            ResizeRedraw = true;
        }

        // Draw a sample equation.
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAliasGridFit;
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            using (Font font = new Font("Times New Roman", 16))
            {
                // Make the equation.
                Equation equation =
                    new IntegralEquation(
                        new BarEquation(
                            new MatrixEquation(3, 4, false, false,
                                new FractionEquation("A", "B", true),
                                new StringEquation("(0, 1)"),
                                new StringEquation("(0, 2)"),
                                new StringEquation("(0, 3)"),
                                new StringEquation("(1, 0)"),
                                new StringEquation("<middle>"),
                                new StringEquation("(1, 2)"),
                                new StringEquation("(1, 3)"),
                                new StringEquation("(2, 0)"),
                                new RootEquation(
                                    new StringEquation("e"),
                                    new SigmaEquation(
                                        new PowerEquation("X", "2"),
                                        new StringEquation("100"),
                                        new StringEquation("X = 1")
                                    )
                                ),
                                new StringEquation("(2, 2)"),
                                new StringEquation("(2, 3)")
                            ),
                            BarEquation.BarStyles.Parenthesis,
                            BarEquation.BarStyles.Parenthesis
                        ),
                        new StringEquation("y = 10"),
                        new StringEquation("y = 1")
                    );

                // Set the equation font sizes.
                equation.SetFontSizes(18);

                // See how big it is.
                SizeF equation_size = equation.GetSize(e.Graphics, font);

                // See where to put the equation to center it.
                float x = (ClientSize.Width - equation_size.Width) / 2;
                float y = (ClientSize.Height - equation_size.Height) / 2;

                // Draw the equation's area.
                e.Graphics.FillRectangle(Brushes.White, x, y,
                    equation_size.Width, equation_size.Height);

                // Draw the equation.
                equation.Draw(e.Graphics, font, Pens.Black, Brushes.Black, x, y);
            }
        }
    }
}
